import type { ConcurrencyOptions } from './poly-iterable.js';
export interface ConcurrentMapperItem<T, U> {
    original: T;
    mapped: U;
    index: number;
}
export type ConcurrentMapperFunction<T, U> = (item: T, index: number) => U | PromiseLike<U>;
export declare class ConcurrentMapper<T, U> implements AsyncIterableIterator<ConcurrentMapperItem<T, U>> {
    #private;
    constructor(iteratorOrIterable: AsyncIterable<T>, mapper: ConcurrentMapperFunction<T, U>, options: ConcurrencyOptions);
    next(): Promise<IteratorResult<ConcurrentMapperItem<T, U>>>;
    [Symbol.asyncIterator](): AsyncIterableIterator<ConcurrentMapperItem<T, U>>;
}
//# sourceMappingURL=concurrency.d.ts.map