"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ConcurrentMapper_instances, _ConcurrentMapper_iterator, _ConcurrentMapper_iteratorNextIndex, _ConcurrentMapper_iteratorDone, _ConcurrentMapper_mapper, _ConcurrentMapper_concurrency, _ConcurrentMapper_buffer, _ConcurrentMapper_bufferCurrentIndex, _ConcurrentMapper_bufferActiveSize, _ConcurrentMapper_bufferUsedSize, _ConcurrentMapper_fillBuffer;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConcurrentMapper = void 0;
class ConcurrentMapper {
    constructor(iteratorOrIterable, mapper, options) {
        var _a, _b;
        _ConcurrentMapper_instances.add(this);
        _ConcurrentMapper_iterator.set(this, void 0);
        _ConcurrentMapper_iteratorNextIndex.set(this, 0);
        _ConcurrentMapper_iteratorDone.set(this, false);
        _ConcurrentMapper_mapper.set(this, void 0);
        _ConcurrentMapper_concurrency.set(this, void 0);
        _ConcurrentMapper_buffer.set(this, void 0);
        _ConcurrentMapper_bufferCurrentIndex.set(this, 0);
        _ConcurrentMapper_bufferActiveSize.set(this, 0);
        _ConcurrentMapper_bufferUsedSize.set(this, 0);
        const concurrency = Math.floor((_a = options.concurrency) !== null && _a !== void 0 ? _a : 0);
        const bufferSize = Math.floor((_b = options.bufferSize) !== null && _b !== void 0 ? _b : Math.max(concurrency, 1));
        if (concurrency < 0)
            throw new TypeError('concurrency must be >= 0');
        if (bufferSize < concurrency)
            throw new TypeError('buffer size must be >= concurrency');
        __classPrivateFieldSet(this, _ConcurrentMapper_iterator, iteratorOrIterable[Symbol.asyncIterator](), "f");
        __classPrivateFieldSet(this, _ConcurrentMapper_mapper, mapper, "f");
        __classPrivateFieldSet(this, _ConcurrentMapper_concurrency, concurrency, "f");
        __classPrivateFieldSet(this, _ConcurrentMapper_buffer, Array(bufferSize).fill(null), "f");
    }
    next() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            if (__classPrivateFieldGet(this, _ConcurrentMapper_iteratorDone, "f")) {
                return { value: undefined, done: true };
            }
            __classPrivateFieldGet(this, _ConcurrentMapper_instances, "m", _ConcurrentMapper_fillBuffer).call(this);
            const bufferItem = __classPrivateFieldGet(this, _ConcurrentMapper_buffer, "f")[__classPrivateFieldGet(this, _ConcurrentMapper_bufferCurrentIndex, "f")];
            __classPrivateFieldSet(this, _ConcurrentMapper_bufferCurrentIndex, (__classPrivateFieldGet(this, _ConcurrentMapper_bufferCurrentIndex, "f") + 1) % __classPrivateFieldGet(this, _ConcurrentMapper_buffer, "f").length, "f");
            __classPrivateFieldSet(this, _ConcurrentMapper_bufferUsedSize, (_a = __classPrivateFieldGet(this, _ConcurrentMapper_bufferUsedSize, "f"), _a--, _a), "f");
            const result = yield bufferItem.mappedPromise;
            if (bufferItem.done) {
                __classPrivateFieldSet(this, _ConcurrentMapper_iteratorDone, true, "f");
                return { done: true, value: undefined };
            }
            else {
                const item = {
                    original: bufferItem.original.value,
                    mapped: result,
                    index: bufferItem.index,
                };
                return { done: false, value: item };
            }
        });
    }
    [(_ConcurrentMapper_iterator = new WeakMap(), _ConcurrentMapper_iteratorNextIndex = new WeakMap(), _ConcurrentMapper_iteratorDone = new WeakMap(), _ConcurrentMapper_mapper = new WeakMap(), _ConcurrentMapper_concurrency = new WeakMap(), _ConcurrentMapper_buffer = new WeakMap(), _ConcurrentMapper_bufferCurrentIndex = new WeakMap(), _ConcurrentMapper_bufferActiveSize = new WeakMap(), _ConcurrentMapper_bufferUsedSize = new WeakMap(), _ConcurrentMapper_instances = new WeakSet(), _ConcurrentMapper_fillBuffer = function _ConcurrentMapper_fillBuffer() {
        var _a, _b, _c, _d;
        while (!__classPrivateFieldGet(this, _ConcurrentMapper_iteratorDone, "f") &&
            __classPrivateFieldGet(this, _ConcurrentMapper_bufferUsedSize, "f") < __classPrivateFieldGet(this, _ConcurrentMapper_buffer, "f").length &&
            __classPrivateFieldGet(this, _ConcurrentMapper_bufferActiveSize, "f") < Math.max(__classPrivateFieldGet(this, _ConcurrentMapper_concurrency, "f"), 1)) {
            const index = (__classPrivateFieldSet(this, _ConcurrentMapper_iteratorNextIndex, (_b = __classPrivateFieldGet(this, _ConcurrentMapper_iteratorNextIndex, "f"), _a = _b++, _b), "f"), _a);
            const originalPromise = __classPrivateFieldGet(this, _ConcurrentMapper_iterator, "f").next();
            const bufferItem = {
                index,
                originalPromise,
                mappedPromise: originalPromise.then((original) => {
                    bufferItem.original = original;
                    bufferItem.done = original.done;
                    if (!original.done) {
                        return __classPrivateFieldGet(this, _ConcurrentMapper_mapper, "f").call(this, original.value, index);
                    }
                }),
            };
            const bufferIndex = (__classPrivateFieldGet(this, _ConcurrentMapper_bufferCurrentIndex, "f") + __classPrivateFieldGet(this, _ConcurrentMapper_bufferUsedSize, "f")) % __classPrivateFieldGet(this, _ConcurrentMapper_buffer, "f").length;
            __classPrivateFieldGet(this, _ConcurrentMapper_buffer, "f")[bufferIndex] = bufferItem;
            __classPrivateFieldSet(this, _ConcurrentMapper_bufferActiveSize, (_c = __classPrivateFieldGet(this, _ConcurrentMapper_bufferActiveSize, "f"), _c++, _c), "f");
            __classPrivateFieldSet(this, _ConcurrentMapper_bufferUsedSize, (_d = __classPrivateFieldGet(this, _ConcurrentMapper_bufferUsedSize, "f"), _d++, _d), "f");
            bufferItem.mappedPromise.then(() => {
                var _a;
                __classPrivateFieldSet(this, _ConcurrentMapper_bufferActiveSize, (_a = __classPrivateFieldGet(this, _ConcurrentMapper_bufferActiveSize, "f"), _a--, _a), "f");
                if (__classPrivateFieldGet(this, _ConcurrentMapper_concurrency, "f") > 0) {
                    __classPrivateFieldGet(this, _ConcurrentMapper_instances, "m", _ConcurrentMapper_fillBuffer).call(this);
                }
            });
        }
    }, Symbol.asyncIterator)]() {
        return this;
    }
}
exports.ConcurrentMapper = ConcurrentMapper;
//# sourceMappingURL=concurrency.js.map