"use strict";
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
};
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
    function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
    function verb(n, f) { if (g[n]) { i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; if (f) i[n] = f(i[n]); } }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sortGen = exports.reverseGen = exports.uniqueGen = exports.groupByGen = exports.chunkWhileGen = exports.chunkGen = exports.flattenGen = exports.tapGen = exports.mapGen = exports.filterGen = exports.sliceGen = exports.takeWhileGen = exports.dropWhileGen = exports.takeLastGen = exports.dropLastGen = exports.takeGen = exports.dropGen = exports.prependGen = exports.appendGen = exports.prefetchGen = void 0;
const concurrency_js_1 = require("./concurrency.js");
function prefetchGen(iterable) {
    const it = iterable[Symbol.asyncIterator]();
    let prom = it.next();
    return {
        [Symbol.asyncIterator]() {
            return {
                next() {
                    const oldProm = prom;
                    prom = it.next();
                    return oldProm;
                },
            };
        },
    };
}
exports.prefetchGen = prefetchGen;
function appendGen(iterA, iterB) {
    return __asyncGenerator(this, arguments, function* appendGen_1() {
        yield __await(yield* __asyncDelegator(__asyncValues(iterA)));
        yield __await(yield* __asyncDelegator(__asyncValues(iterB)));
    });
}
exports.appendGen = appendGen;
function prependGen(iterA, iterB) {
    return __asyncGenerator(this, arguments, function* prependGen_1() {
        yield __await(yield* __asyncDelegator(__asyncValues(iterB)));
        yield __await(yield* __asyncDelegator(__asyncValues(iterA)));
    });
}
exports.prependGen = prependGen;
function dropGen(iter, num) {
    return __asyncGenerator(this, arguments, function* dropGen_1() {
        var _a, e_1, _b, _c;
        let rem = num;
        try {
            for (var _d = true, iter_1 = __asyncValues(iter), iter_1_1; iter_1_1 = yield __await(iter_1.next()), _a = iter_1_1.done, !_a; _d = true) {
                _c = iter_1_1.value;
                _d = false;
                const elem = _c;
                if (rem-- <= 0) {
                    yield yield __await(elem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_1.return)) yield __await(_b.call(iter_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
exports.dropGen = dropGen;
function takeGen(iter, num) {
    return __asyncGenerator(this, arguments, function* takeGen_1() {
        var _a, e_2, _b, _c;
        let rem = num;
        try {
            for (var _d = true, iter_2 = __asyncValues(iter), iter_2_1; iter_2_1 = yield __await(iter_2.next()), _a = iter_2_1.done, !_a; _d = true) {
                _c = iter_2_1.value;
                _d = false;
                const elem = _c;
                if (rem-- <= 0) {
                    return yield __await(void 0);
                }
                yield yield __await(elem);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_2.return)) yield __await(_b.call(iter_2));
            }
            finally { if (e_2) throw e_2.error; }
        }
    });
}
exports.takeGen = takeGen;
function dropLastGen(iter, num) {
    return __asyncGenerator(this, arguments, function* dropLastGen_1() {
        var _a, e_3, _b, _c;
        const buf = Array(num);
        let pos = 0;
        let size = 0;
        try {
            for (var _d = true, iter_3 = __asyncValues(iter), iter_3_1; iter_3_1 = yield __await(iter_3.next()), _a = iter_3_1.done, !_a; _d = true) {
                _c = iter_3_1.value;
                _d = false;
                const elem = _c;
                if (size >= num) {
                    yield yield __await(num ? buf[pos] : elem);
                }
                else {
                    size++;
                }
                if (num) {
                    buf[pos] = elem;
                    pos = ((pos + 1) % num);
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_3.return)) yield __await(_b.call(iter_3));
            }
            finally { if (e_3) throw e_3.error; }
        }
    });
}
exports.dropLastGen = dropLastGen;
function takeLastGen(iter, num) {
    return __asyncGenerator(this, arguments, function* takeLastGen_1() {
        var _a, e_4, _b, _c;
        const buf = Array(num);
        let pos = 0;
        let size = 0;
        try {
            for (var _d = true, iter_4 = __asyncValues(iter), iter_4_1; iter_4_1 = yield __await(iter_4.next()), _a = iter_4_1.done, !_a; _d = true) {
                _c = iter_4_1.value;
                _d = false;
                const elem = _c;
                size = size >= num ? num : size + 1;
                if (num) {
                    buf[pos] = elem;
                    pos = ((pos + 1) % num);
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_4.return)) yield __await(_b.call(iter_4));
            }
            finally { if (e_4) throw e_4.error; }
        }
        pos = size >= num ? pos : 0;
        for (let i = 0; i < size; i++) {
            yield yield __await(buf[pos]);
            pos = ((pos + 1) % num);
        }
    });
}
exports.takeLastGen = takeLastGen;
function dropWhileGen(iter, func) {
    return __asyncGenerator(this, arguments, function* dropWhileGen_1() {
        var _a, e_5, _b, _c;
        let idx = 0;
        let yielding = false;
        try {
            for (var _d = true, iter_5 = __asyncValues(iter), iter_5_1; iter_5_1 = yield __await(iter_5.next()), _a = iter_5_1.done, !_a; _d = true) {
                _c = iter_5_1.value;
                _d = false;
                const elem = _c;
                if (yielding || !(yield __await(func(elem, idx++)))) {
                    yielding = true;
                    yield yield __await(elem);
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_5.return)) yield __await(_b.call(iter_5));
            }
            finally { if (e_5) throw e_5.error; }
        }
    });
}
exports.dropWhileGen = dropWhileGen;
function takeWhileGen(iter, func) {
    return __asyncGenerator(this, arguments, function* takeWhileGen_1() {
        var _a, e_6, _b, _c;
        let idx = 0;
        try {
            for (var _d = true, iter_6 = __asyncValues(iter), iter_6_1; iter_6_1 = yield __await(iter_6.next()), _a = iter_6_1.done, !_a; _d = true) {
                _c = iter_6_1.value;
                _d = false;
                const elem = _c;
                if (!(yield __await(func(elem, idx++)))) {
                    return yield __await(void 0);
                }
                yield yield __await(elem);
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_6.return)) yield __await(_b.call(iter_6));
            }
            finally { if (e_6) throw e_6.error; }
        }
    });
}
exports.takeWhileGen = takeWhileGen;
function sliceNegPosGen(iter, start, end) {
    return __asyncGenerator(this, arguments, function* sliceNegPosGen_1() {
        var _a, e_7, _b, _c;
        const buf = Array(start);
        let pos = 0;
        let size = 0;
        let num = end;
        try {
            for (var _d = true, iter_7 = __asyncValues(iter), iter_7_1; iter_7_1 = yield __await(iter_7.next()), _a = iter_7_1.done, !_a; _d = true) {
                _c = iter_7_1.value;
                _d = false;
                const elem = _c;
                if (size >= start && end) {
                    num--;
                }
                size = size >= start ? start : size + 1;
                if (start) {
                    buf[pos] = elem;
                    pos = ((pos + 1) % start);
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_7.return)) yield __await(_b.call(iter_7));
            }
            finally { if (e_7) throw e_7.error; }
        }
        pos = size >= start ? pos : 0;
        for (let i = 0; i < Math.min(size, num); i++) {
            yield yield __await(buf[pos]);
            pos = ((pos + 1) % start);
        }
    });
}
function sliceGen(iter, start, end) {
    if (start >= 0 && end == null) {
        return dropGen(iter, start);
    }
    else if (end == null) { // && start < 0
        return takeLastGen(iter, -start);
    }
    else if (start >= 0 && end >= 0) {
        return takeGen(dropGen(iter, start), end - start);
    }
    else if (start < 0 && end >= 0) {
        return sliceNegPosGen(iter, -start, end);
    }
    else if (start >= 0) { // && end < 0
        return dropLastGen(dropGen(iter, start), -end);
    }
    else { // start < 0 && end < 0
        return dropLastGen(takeLastGen(iter, -start), -end);
    }
}
exports.sliceGen = sliceGen;
function filterGen(iter, func, options) {
    return __asyncGenerator(this, arguments, function* filterGen_1() {
        var _a, e_8, _b, _c;
        const concIter = new concurrency_js_1.ConcurrentMapper(iter, func, options);
        try {
            for (var _d = true, concIter_1 = __asyncValues(concIter), concIter_1_1; concIter_1_1 = yield __await(concIter_1.next()), _a = concIter_1_1.done, !_a; _d = true) {
                _c = concIter_1_1.value;
                _d = false;
                const elem = _c;
                if (elem.mapped) {
                    yield yield __await(elem.original);
                }
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = concIter_1.return)) yield __await(_b.call(concIter_1));
            }
            finally { if (e_8) throw e_8.error; }
        }
    });
}
exports.filterGen = filterGen;
function mapGen(iter, func, options) {
    return __asyncGenerator(this, arguments, function* mapGen_1() {
        var _a, e_9, _b, _c;
        const concIter = new concurrency_js_1.ConcurrentMapper(iter, func, options);
        try {
            for (var _d = true, concIter_2 = __asyncValues(concIter), concIter_2_1; concIter_2_1 = yield __await(concIter_2.next()), _a = concIter_2_1.done, !_a; _d = true) {
                _c = concIter_2_1.value;
                _d = false;
                const elem = _c;
                yield yield __await(elem.mapped);
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = concIter_2.return)) yield __await(_b.call(concIter_2));
            }
            finally { if (e_9) throw e_9.error; }
        }
    });
}
exports.mapGen = mapGen;
function tapGen(iter, func, options) {
    return __asyncGenerator(this, arguments, function* tapGen_1() {
        var _a, e_10, _b, _c;
        const concIter = new concurrency_js_1.ConcurrentMapper(iter, func, options);
        try {
            for (var _d = true, concIter_3 = __asyncValues(concIter), concIter_3_1; concIter_3_1 = yield __await(concIter_3.next()), _a = concIter_3_1.done, !_a; _d = true) {
                _c = concIter_3_1.value;
                _d = false;
                const elem = _c;
                yield yield __await(elem.original);
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = concIter_3.return)) yield __await(_b.call(concIter_3));
            }
            finally { if (e_10) throw e_10.error; }
        }
    });
}
exports.tapGen = tapGen;
function flattenGen(iter) {
    return __asyncGenerator(this, arguments, function* flattenGen_1() {
        var _a, e_11, _b, _c;
        try {
            for (var _d = true, iter_8 = __asyncValues(iter), iter_8_1; iter_8_1 = yield __await(iter_8.next()), _a = iter_8_1.done, !_a; _d = true) {
                _c = iter_8_1.value;
                _d = false;
                const elem = _c;
                yield __await(yield* __asyncDelegator(__asyncValues(elem)));
            }
        }
        catch (e_11_1) { e_11 = { error: e_11_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_8.return)) yield __await(_b.call(iter_8));
            }
            finally { if (e_11) throw e_11.error; }
        }
    });
}
exports.flattenGen = flattenGen;
function chunkGen(iter, num) {
    return __asyncGenerator(this, arguments, function* chunkGen_1() {
        var _a, e_12, _b, _c;
        let chunk = [];
        try {
            for (var _d = true, iter_9 = __asyncValues(iter), iter_9_1; iter_9_1 = yield __await(iter_9.next()), _a = iter_9_1.done, !_a; _d = true) {
                _c = iter_9_1.value;
                _d = false;
                const elem = _c;
                chunk.push(elem);
                if (chunk.length === num) {
                    yield yield __await(chunk);
                    chunk = [];
                }
            }
        }
        catch (e_12_1) { e_12 = { error: e_12_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_9.return)) yield __await(_b.call(iter_9));
            }
            finally { if (e_12) throw e_12.error; }
        }
        if (chunk.length) {
            yield yield __await(chunk);
        }
    });
}
exports.chunkGen = chunkGen;
function chunkWhileGen(iter, func) {
    return __asyncGenerator(this, arguments, function* chunkWhileGen_1() {
        var _a, e_13, _b, _c;
        let chunk = [];
        try {
            for (var _d = true, iter_10 = __asyncValues(iter), iter_10_1; iter_10_1 = yield __await(iter_10.next()), _a = iter_10_1.done, !_a; _d = true) {
                _c = iter_10_1.value;
                _d = false;
                const elem = _c;
                if (chunk.length === 0 || (yield __await(func(elem, chunk[chunk.length - 1], chunk[0])))) {
                    chunk.push(elem);
                }
                else {
                    yield yield __await(chunk);
                    chunk = [elem];
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_10.return)) yield __await(_b.call(iter_10));
            }
            finally { if (e_13) throw e_13.error; }
        }
        if (chunk.length) {
            yield yield __await(chunk);
        }
    });
}
exports.chunkWhileGen = chunkWhileGen;
function groupByGen(iter, func, options) {
    var _a;
    return __asyncGenerator(this, arguments, function* groupByGen_1() {
        var _b, e_14, _c, _d;
        const groups = new Map();
        const concIter = new concurrency_js_1.ConcurrentMapper(iter, func, options);
        try {
            for (var _e = true, concIter_4 = __asyncValues(concIter), concIter_4_1; concIter_4_1 = yield __await(concIter_4.next()), _b = concIter_4_1.done, !_b; _e = true) {
                _d = concIter_4_1.value;
                _e = false;
                const elem = _d;
                const key = elem.mapped;
                const group = (_a = groups.get(key)) !== null && _a !== void 0 ? _a : [];
                group.push(elem.original);
                groups.set(key, group);
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (!_e && !_b && (_c = concIter_4.return)) yield __await(_c.call(concIter_4));
            }
            finally { if (e_14) throw e_14.error; }
        }
        yield __await(yield* __asyncDelegator(__asyncValues(groups.entries())));
    });
}
exports.groupByGen = groupByGen;
function uniqueGen(iter, func, options) {
    return __asyncGenerator(this, arguments, function* uniqueGen_1() {
        var _a, e_15, _b, _c;
        const seen = new Set();
        const concIter = new concurrency_js_1.ConcurrentMapper(iter, func, options);
        try {
            for (var _d = true, concIter_5 = __asyncValues(concIter), concIter_5_1; concIter_5_1 = yield __await(concIter_5.next()), _a = concIter_5_1.done, !_a; _d = true) {
                _c = concIter_5_1.value;
                _d = false;
                const elem = _c;
                const key = elem.mapped;
                if (!seen.has(key)) {
                    yield yield __await(elem.original);
                    seen.add(key);
                }
            }
        }
        catch (e_15_1) { e_15 = { error: e_15_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = concIter_5.return)) yield __await(_b.call(concIter_5));
            }
            finally { if (e_15) throw e_15.error; }
        }
    });
}
exports.uniqueGen = uniqueGen;
function reverseGen(iter) {
    return __asyncGenerator(this, arguments, function* reverseGen_1() {
        var _a, e_16, _b, _c;
        const buf = [];
        try {
            for (var _d = true, iter_11 = __asyncValues(iter), iter_11_1; iter_11_1 = yield __await(iter_11.next()), _a = iter_11_1.done, !_a; _d = true) {
                _c = iter_11_1.value;
                _d = false;
                const elem = _c;
                buf.push(elem);
            }
        }
        catch (e_16_1) { e_16 = { error: e_16_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iter_11.return)) yield __await(_b.call(iter_11));
            }
            finally { if (e_16) throw e_16.error; }
        }
        for (let i = buf.length - 1; i >= 0; i--) {
            yield yield __await(buf[i]);
        }
    });
}
exports.reverseGen = reverseGen;
function sortGen(iter, func) {
    return __asyncGenerator(this, arguments, function* sortGen_1() {
        var _a, e_17, _b, _c, _d, e_18, _e, _f;
        const buf = [];
        try {
            for (var _g = true, iter_12 = __asyncValues(iter), iter_12_1; iter_12_1 = yield __await(iter_12.next()), _a = iter_12_1.done, !_a; _g = true) {
                _c = iter_12_1.value;
                _g = false;
                const elem = _c;
                buf.push(elem);
            }
        }
        catch (e_17_1) { e_17 = { error: e_17_1 }; }
        finally {
            try {
                if (!_g && !_a && (_b = iter_12.return)) yield __await(_b.call(iter_12));
            }
            finally { if (e_17) throw e_17.error; }
        }
        try {
            for (var _h = true, _j = __asyncValues(buf.sort(func)), _k; _k = yield __await(_j.next()), _d = _k.done, !_d; _h = true) {
                _f = _k.value;
                _h = false;
                const elem = _f;
                yield yield __await(elem);
            }
        }
        catch (e_18_1) { e_18 = { error: e_18_1 }; }
        finally {
            try {
                if (!_h && !_d && (_e = _j.return)) yield __await(_e.call(_j));
            }
            finally { if (e_18) throw e_18.error; }
        }
    });
}
exports.sortGen = sortGen;
//# sourceMappingURL=generators.js.map