"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
    function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
    function verb(n, f) { if (g[n]) { i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; if (f) i[n] = f(i[n]); } }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var _PolyAsyncIterable_iterable;
Object.defineProperty(exports, "__esModule", { value: true });
const utils_js_1 = require("../utils.js");
const concurrency_js_1 = require("./concurrency.js");
const generators_js_1 = require("./generators.js");
const NOOP = (x) => x;
/**
 * An `AsyncIterable<T>` with a suite of methods for transforming the iteration into other iterations or to get a
 * single result from it.
 *
 * This class works as an async version of {@link PolySyncIterable}, but all methods accept async function where
 * possible and will always return either `PolyAsyncIterables` or a `Promise` to a value.
 *
 * ## Concurrency
 * Many operations of this class accept as a final argument an {@link ConcurrencyOptions | options object} than can
 * specify some options for concurrent operations.
 *
 * - The `concurrency` option will specify how many times whatever `func` you pass is called before waiting for its
 * results.  Effectively, this is the number of promises that can be pending at the same time.  If not specified, it
 * will default to 0, meaning no concurrency.  Must be a non-negative integer.
 * - The `bufferSize` option will specify the size of the internal buffer used to store the pending and completed
 * promises.  Effectively, this is how many results will be prefetched.  If not specified, it will default to
 * `concurrency`, meaning no extra intermediate results are stored.  Must be a positive integer greater or equal to
 * `concurrency`.
 *
 * A concurrency value of 0 acts the same as a 1 concurrency-wise, but disables the concurrency completely, preventing
 * any values to be requested before actually needed.
 *
 * Specifying concurrency greater or equal to 1 will make more elements be requested of the previous iterator than
 * actually requested of the current one, similarly to {@link PolyAsyncIterable.prefetch}.
 *
 * @public
 */
class PolyAsyncIterable {
    /** @internal */
    constructor(iterable) {
        _PolyAsyncIterable_iterable.set(this, void 0);
        __classPrivateFieldSet(this, _PolyAsyncIterable_iterable, iterable, "f");
    }
    /**
     * Allows this class to work as a regular `AsyncIterable<T>`
     *
     * @returns an async iterable that will yield the same elements as the iterable used to create this instance
     */
    [(_PolyAsyncIterable_iterable = new WeakMap(), Symbol.asyncIterator)]() {
        return __classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")[Symbol.asyncIterator]();
    }
    /**
     * Return `this`.
     *
     * @remarks
     * This method is present in this class for compatibility with {@link PolySyncIterable.async}, but it's never
     * necessary to call it for anything.
     *
     * @returns A {@link PolyAsyncIterable} that yields the same elements as `this`
     */
    async() {
        return this;
    }
    /**
     * Return the same iteration, but with its elements requested with anticipation to allow for asynchronous operations
     * to begin and reduce wait times.
     *
     * @remarks
     * When yielding an element of this iterable, the next one will be also requested internally, so that any
     * asynchronous operations are started before their results are needed.
     *
     * Note that after calling this mehtod, more elements than strictly needed might be requested from the previous
     * iterable, triggering any potential side effects.
     *
     * @returns a new {@link PolyAsyncIterable} that prefetched the iterated elementsd
     */
    prefetch() {
        return new PolyAsyncIterable((0, generators_js_1.prefetchGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")));
    }
    /**
     * Return a new iteration that will iterate over `this`, then over `other`.
     *
     * @remarks
     * The resulting iteration is of the combined generic type of `this` and `other`, allowing this method to merge the
     * types of two distinct iterables.
     *
     * @typeParam U - Type of the elements to be appended
     * @param other - Iterable to be appended
     * @returns a new {@link PolyAsyncIterable} that yields the elements of `this` and then the elements of `other`
     */
    append(other) {
        utils_js_1.asserts.isSyncOrAsyncIterable(other);
        return new PolyAsyncIterable((0, generators_js_1.appendGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), other));
    }
    /**
     * Return a new iteration that will iterate over `this`, then over `other`.
     *
     * @remarks
     * This method is an alias for {@link PolyAsyncIterable.append}.
     *
     * @typeParam U - Type of the elements to be appended
     * @param other - Iterable to be appended
     * @returns a new {@link PolySyncIterable} that yields the elements of `this` and then the elements of `other`
     */
    concat(other) {
        return this.append(other);
    }
    /**
     * Return a new iteration that will iterate over `other`, then over `this`.
     *
     * @remarks
     * The resulting iteration is of the combined generic type of `this` and `other`, allowing this method to merge the
     * types of two distinct iterables.
     *
     * @typeParam U - Type of the elements to be prepended
     * @param other - Iterable to be prepended
     * @returns a new {@link PolyAsyncIterable} that yields the elements of `other` and then the elements of `this`
     */
    prepend(other) {
        utils_js_1.asserts.isSyncOrAsyncIterable(other);
        return new PolyAsyncIterable((0, generators_js_1.prependGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), other));
    }
    /**
     * Return a new iteration that skips the first `num` elements.  If there were less than `num` elements in the
     * iteration, no elements are yielded.
     *
     * @param num - The number of elements to skip
     * @returns a new {@link PolyAsyncIterable} that yields the same the elements of `this`, except for the first
     * `num` elements
     */
    drop(num) {
        utils_js_1.asserts.isNonNegativeInteger(num);
        return new PolyAsyncIterable((0, generators_js_1.dropGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), num));
    }
    /**
     * Return a new iteration that iterates only over the first `num` elements.  If there were less than than `num`
     * elements in the iteration, all elements are yielded with no additions.
     *
     * @param num - The number of elements to yield
     * @returns a new {@link PolyAsyncIterable} that yields the first `num` elements elements of `this`
     */
    take(num) {
        utils_js_1.asserts.isNonNegativeInteger(num);
        return new PolyAsyncIterable((0, generators_js_1.takeGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), num));
    }
    /**
     * Return a new iteration that skips the last `num` elements.  If there were less than `num` elements in the
     * iteration, no elements are yielded.
     *
     * @remarks
     * The returned iteration keeps a buffer of `num` elements internally in order to skip those if the iteration ends,
     * and so elements effectively get delayed by `num` elements.
     *
     * @param num - The number of elements to skip
     * @returns a new {@link PolyAsyncIterable} that yields the same the elements of `this`, except for the last
     * `num` elements
     */
    dropLast(num) {
        utils_js_1.asserts.isNonNegativeInteger(num);
        return new PolyAsyncIterable((0, generators_js_1.dropLastGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), num));
    }
    /**
     * Return a new iteration that iterates only over the last `num` elements.  If there were less than than `num`
     * elements in the iteration, all elements are yielded with no additions.
     *
     * @remarks
     * The returned iteration keeps a buffer of `num` elements internally in order to know which elements to keep.
     * and so elements effectively get delayed until the iteration ends.
     *
     * @param num - The number of elements to yield
     * @returns a new {@link PolyAsyncIterable} that yields the last `num` elements elements of `this`
     */
    takeLast(num) {
        utils_js_1.asserts.isNonNegativeInteger(num);
        return new PolyAsyncIterable((0, generators_js_1.takeLastGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), num));
    }
    /**
     * Return a new iteration that skips the first few elements for which `func(element)` returns `true`.
     *
     * @param func - The function to call on the elements
     * @returns a new {@link PolyAsyncIterable} that yields the same the elements of `this`, excepts the first few for
     * which`func(element)` returns `true`
     */
    dropWhile(func) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.dropWhileGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func));
    }
    takeWhile(func) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.takeWhileGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func));
    }
    /**
     * Return a new iteration that starts from the `start`th element (included)
     * and ends at the `end`th element (excluded) of `this`.
     *
     * @remarks
     * Both `start` and `end` allow for negative values, in which case they refer to the nth-to-last element,
     * with n being the absolute value of the argument.  `end` might also be `undefined`, in which case the iteration is
     * not shortened on the end side, yielding up to the end, including the last element.
     * This mimics the behaviour of {@link https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array/slice | Array.slice}.
     *
     * This function will likely need a buffer, effectively delaying the yielding of elements for a while.
     *
     * @param start - The index of the first element returned
     * @param end - The index of the first element *not* returned, inclusive
     * @returns a new {@link PolyAsyncIterable} that yields the elements going that starts from the `start`th element
     * (included) and ends at the `end`th element (excluded) of `this`
     */
    slice(start, end) {
        utils_js_1.asserts.isInteger(start, 'start');
        utils_js_1.asserts.isInteger(end !== null && end !== void 0 ? end : 0, 'end');
        return new PolyAsyncIterable((0, generators_js_1.sliceGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), start, end));
    }
    filter(func, options = {}) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.filterGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options));
    }
    /**
     * Return an iteration of all the elements as `this` that aren't `null` or `undefined`.
     *
     * @remarks
     * This function is a shortcut to calling {@link PolyAsyncIterable.filter.(:FILTER_TYPEPRED) filter} with a type
     * predicate function that correctly filters out `null` and `undefined` values from the iteration.  Note that other
     * falsy values will remain in the iteration, and that the return value is correctly typed to exclude
     * `null` and `undefined`.
     *
     * @returns A new {@link PolyAsyncIterable} that yields the same elements as `this`
     * except for `null` or `undefined` values
     */
    filterNotNullish() {
        return this.filter(utils_js_1.isNotNullish);
    }
    /**
     * Return an iteration of the result of calling `func(element)` for every element in `this`.
     *
     * @typeParam U - The return type of `func` and the generic type of the resulting iterable
     * @param func - A function that takes an element of `this` and returns something else
     * @param options - Options for concurrency of this operation
     * @returns A new {@link PolyAsyncIterable} that yields the results of calling `func(element)`
     * for every element of `this`
     */
    map(func, options = {}) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.mapGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options));
    }
    /**
     * Return an iteration of the pairs resulting of calling `func(element)` for every element in `this` and using it as
     * the first element of the pair (the *key*) and preserving the second (the *value*).
     *
     * @remarks
     * This method is only available for iterations of pairs.
     *
     * @typeParam K1 - The key type of the original iterable, as passed to `func`
     * @typeParam K2 - The key type of the resulting iterable, as returned from `func`
     * @typeParam V - The value type of the original and resulting iterables, as passed to `func`
     * @param func - A function that takes an element of `this` and returns something else
     * @returns A new {@link PolySyncIterable} that yields the results of calling `func(element)`
     * for every element of `this` and using it to replace the keys
     */
    mapKeys(func, options = {}) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.mapGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), ([k, v], index) => __awaiter(this, void 0, void 0, function* () { return [yield func([k, v], index), v]; }), options));
    }
    /**
     * Return an iteration of the pairs resulting of calling `func(element)` for every element in `this` and using it as
     * the second element of the pair (the *value*) and preserving the first (the *key*).
     *
     * @remarks
     * This method is only available for iterations of pairs.
     *
     * @typeParam K - The key type of the original and resulting iterables, as passed to `func`
     * @typeParam V1 - The value type of the original iterable, as passed to `func`
     * @typeParam V2 - The value type of the resulting iterable, as returned from `func`
     * @param func - A function that takes an element of `this` and returns something else
     * @returns A new {@link PolySyncIterable} that yields the results of calling `func(element)`
     * for every element of `this` and using it to replace the values
     */
    mapValues(func, options = {}) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.mapGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), ([k, v], index) => __awaiter(this, void 0, void 0, function* () { return [k, yield func([k, v], index)]; }), options));
    }
    /**
     * Return an iteration of the same elements as `this` after calling `func(element)` for all elements.
     *
     * @typeParam U - The return type of `func`
     * @param func - A function called for all elements
     * @param options - Options for concurrency of this operation
     * @returns A new {@link PolyAsyncIterable} that yields the same elements as `this`
     */
    tap(func, options = {}) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.tapGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options));
    }
    /**
     * Return an iteration of the yielded elements of the sub-iterables.
     *
     * @typeParam U - The type of the sub-iterable elements
     * @returns A new {@link PolyAsyncIterable} that will yield the elements of all sub-iterables
     */
    flatten() {
        return new PolyAsyncIterable((0, generators_js_1.flattenGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")));
    }
    /**
     * Return an iteration of the yielded elements of the sub-iterables.
     *
     * @remarks
     * This method is an alias of {@link PolyAsyncIterable.flatten}.
     *
     * @typeParam U - The type of the sub-iterable elements
     * @returns A new {@link PolyAsyncIterable} that will yield the elements of all sub-iterables
     */
    flat() {
        return this.flatten();
    }
    /**
     * Return an iteration of elements of the sub-iterables that result from calling `func(element)`
     * for every element in `this`.
     *
     * @remarks
     * This method is equivalent to calling {@link PolyAsyncIterable.map | map(func)}
     * and then {@link PolyAsyncIterable.flatten | flatten()}
     *
     * @typeParam U - The type of the sub-iterables returned by `func`
     * @param func - A function that takes an element of `this` and returns an iterable
     * @param options - Options for concurrency of this operation
     * @returns A new {@link PolyAsyncIterable} that yields the elements of the subiterables that results from
     * calling `func(element)` for every element of `this`
     */
    flatMap(func, options) {
        return this.map(func, options).flatten();
    }
    /**
     * Return an iteration of arrays of size `num` (except possibly the last) containing
     * groupings of elements of `this` iteration.
     *
     * @remarks
     * All chunks except possibly the last one will have exactly `num` elements.  The last chunk will have less elements
     * if the number of elements in the iteration is not divisible by `num`.  No chunk will ever be returned empty or
     * have more than `num` elements.
     *
     * @param num - Size of the chunks
     * @returns A new {@link PolyAsyncIterable} that yields arrays of size `num` (except possibly the last) containing
     * groupings of elements of `this`
     */
    chunk(num) {
        utils_js_1.asserts.isPositiveInteger(num);
        return new PolyAsyncIterable((0, generators_js_1.chunkGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), num));
    }
    /**
     * Return an iteration of arrays with elements of this separated based on the result of calling `func(elements)`.
     *
     * @remarks
     * The chunking process works by keeping an open _current chunk_ and calling `func` to decide whether the next
     * element of the iteration will be part of the _current chunk_ or if it will be part of a new chunk.
     *
     * To do this, `func` will be called for every element of the iteration except the first, which will automatically
     * become part of the first chunk.  If `func` returns `true`, the element will be part of the current chunk, and
     * if it returns `false`, the _current chunk_ is closed and the element becomes the first element if the new
     * _current chunk_.
     * The arguments passed to `func` will be, in order:
     *   - `elem` - The element being currently processed
     *   - `lastElem` - The last element that was added to the current chunk
     *   - `firstElem` - The first element of the current chunk (might be the same as `lastElem`)
     *
     * All elements will be part of a chunk, and no chunk will ever be empty.
     *
     * @param func - A function that decides if an element is part of the current chunk or initiates a new one
     * @returns A new {@link PolyAsyncIterable} that yields arrays with the elements of `this` as separated by `func`
     */
    chunkWhile(func) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.chunkWhileGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func));
    }
    /**
     * Return an iteration of group pairs, where the first element is a _group key_ and the second is an iterable of all
     * the elements for which `func(element)` returned the key.
     *
     * @remarks
     * This method is intended to be combined with {@link PolyAsyncIterable.toObject | toObject}
     * or {@link PolyAsyncIterable.toMap | toMap}, thus behaving like
     * {@link https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array/groupBy | Array.groupBy} and
     * {@link https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array/groupByToMap | Array.groupByToMap}
     * respectively, but without losing the ablity to further process the iteration, such as by mapping, filtering, etc.
     *
     * @typeParam K - Type of the keys used to group elements
     * @param func - A function that returns the grouping key of each element
     * @param options - Options for concurrency of this operation
     * @returns A new {@link PolyAsyncIterable} of group pairs with the key and the group
     */
    groupBy(func, options = {}) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.groupByGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options));
    }
    /**
     * Return an iteration of unique elements, where two elements are considered equal if the result of `func(element)` is
     * the same for both elements.
     *
     * @remarks
     * Note that the first element seen with a specific key is always the one yielded, and every other element afterwards
     * is ignored.
     *
     * If no key-mapping function is given, the elements theselves are used as keys.
     * This is likely _not_ what you want in most situations unless elements are primitive types.
     *
     * @param func - A function that returns a _key_ used for uniqueness checks.
     * If not passed, an identitity function is used.
     * @param options - Options for concurrency of this operation
     * @returns A new {@link PolyAsyncIterable} only elements for which `func(element)` returns a value that hasn't
     * been seen before
     */
    unique(func = utils_js_1.asyncIdentity, options = {}) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.uniqueGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options));
    }
    /**
     * Return an iteration of the elements of `this` in reverse order.
     *
     * @remarks
     * This method will buffer _all_ elements of the iteration, and yield them all at once at the end
     *
     * @returns A new {@link PolyAsyncIterable} that yields the elements of `this` in reverse order
     */
    reverse() {
        return new PolyAsyncIterable((0, generators_js_1.reverseGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")));
    }
    /**
     * Return an iteration of the elements of `this` sorted according to `func`
     *
     * @remarks
     * The sort function `func` is used to call
     * {@link https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array/sort | Array.sort}
     * on an array of all the elements.
     * However, the default comparator function will sort elements according to the `<` and `>` operators defined on
     * their own type, of always sorting lexicagraphically like
     * {@link https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array/sort | Array.sort}
     * does.
     *
     * This method will buffer _all_ elements of the iteration, and yield them all at once at the end
     *
     * @param func - A comparator function
     * @returns A new {@link PolyAsyncIterable} that yields the elements of `this` sorted according to `func`
     */
    sort(func = utils_js_1.comparator) {
        utils_js_1.asserts.isFunction(func);
        return new PolyAsyncIterable((0, generators_js_1.sortGen)(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func));
    }
    /**
     * Return an array of all elements of this iteration in the same order that were yielded.
     *
     * @returns A promise to an array that contains the same elements as this iteration, in the same order
     */
    toArray() {
        var _a, e_1, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const array = [];
            try {
                for (var _d = true, _e = __asyncValues(this), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                    _c = _f.value;
                    _d = false;
                    const elem = _c;
                    array.push(elem);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return array;
        });
    }
    toPartitionArrays(func, options = {}) {
        var _a, e_2, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const trues = [];
            const falses = [];
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_1 = __asyncValues(concIter), concIter_1_1; concIter_1_1 = yield concIter_1.next(), _a = concIter_1_1.done, !_a; _d = true) {
                    _c = concIter_1_1.value;
                    _d = false;
                    const elem = _c;
                    if (elem.mapped) {
                        trues.push(elem.original);
                    }
                    else {
                        falses.push(elem.original);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_1.return)) yield _b.call(concIter_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return [trues, falses];
        });
    }
    /**
     * Return an object made from the entries of `this`.
     * This method is roughly equivalent to calling `Object.fromEntires(iter.toArray())`.
     *
     * @remarks
     * This method is only available for iterations of pairs where the first component is a valid object key type.
     *
     * @returns A promise to an object composed of the entries yielded by this iterable.
     */
    toObject() {
        var _a, e_3, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const object = {};
            try {
                for (var _d = true, _e = __asyncValues(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                    _c = _f.value;
                    _d = false;
                    const [key, value] = _c;
                    object[key] = value;
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return object;
        });
    }
    /**
     * Return a `Map` made from the entries of `this`.
     * This method is roughly equivalent to calling `new Map(iter.toArray())`.
     *
     * @remarks
     * This method is only available for iterations of pairs where the first component is a valid object key type.
     *
     * @returns A promise to a `Map` composed of the entries yielded by this iterable.
     */
    toMap() {
        var _a, e_4, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const map = new Map();
            const iterable = __classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f");
            try {
                for (var _d = true, iterable_1 = __asyncValues(iterable), iterable_1_1; iterable_1_1 = yield iterable_1.next(), _a = iterable_1_1.done, !_a; _d = true) {
                    _c = iterable_1_1.value;
                    _d = false;
                    const [key, value] = _c;
                    map.set(key, value);
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_1.return)) yield _b.call(iterable_1);
                }
                finally { if (e_4) throw e_4.error; }
            }
            return map;
        });
    }
    find(func, options = {}) {
        var _a, e_5, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(func);
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_2 = __asyncValues(concIter), concIter_2_1; concIter_2_1 = yield concIter_2.next(), _a = concIter_2_1.done, !_a; _d = true) {
                    _c = concIter_2_1.value;
                    _d = false;
                    const elem = _c;
                    if (elem.mapped) {
                        return elem.original;
                    }
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_2.return)) yield _b.call(concIter_2);
                }
                finally { if (e_5) throw e_5.error; }
            }
            return undefined;
        });
    }
    findLast(func, options = {}) {
        var _a, e_6, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(func);
            let found;
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_3 = __asyncValues(concIter), concIter_3_1; concIter_3_1 = yield concIter_3.next(), _a = concIter_3_1.done, !_a; _d = true) {
                    _c = concIter_3_1.value;
                    _d = false;
                    const elem = _c;
                    if (elem.mapped) {
                        found = elem.original;
                    }
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_3.return)) yield _b.call(concIter_3);
                }
                finally { if (e_6) throw e_6.error; }
            }
            return found;
        });
    }
    /**
     * Returns the index of the first element for which `func(element)` returns `true`, or `-1` if it never does.
     *
     * @remarks
     * `func` will be called on elements of this iteration until it returns `true`, and then not called again.
     *
     * Note that this method is rather useless given that iterables are single-use and have no indexing capabilities,
     * but it's here for completion and consistency with `Array`.
     *
     * @param func - A boolean returning function called for elements of `this`
     * @param options - Options for concurrency of this operation
     * @returns A promise the index of the first element of the iteration for which `func` returned `true`
     */
    findIndex(func, options = {}) {
        var _a, e_7, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(func);
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_4 = __asyncValues(concIter), concIter_4_1; concIter_4_1 = yield concIter_4.next(), _a = concIter_4_1.done, !_a; _d = true) {
                    _c = concIter_4_1.value;
                    _d = false;
                    const elem = _c;
                    if (elem.mapped) {
                        return elem.index;
                    }
                }
            }
            catch (e_7_1) { e_7 = { error: e_7_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_4.return)) yield _b.call(concIter_4);
                }
                finally { if (e_7) throw e_7.error; }
            }
            return -1;
        });
    }
    /**
     * Returns the index of the last element for which `func(element)` returns `true`, or `-1` if it never does.
     *
     * @remarks
     * `func` will be called on *all* of this iteration, and the result will not be returned until the iteration ends.
     *
     * Note that this method is rather useless given that iterables are single-use and have no indexing capabilities,
     * but it's here for completion and consistency with `Array`.
     *
     * @param func - A boolean returning function called for elements of `this`
     * @param options - Options for concurrency of this operation
     * @returns A promise the index of the last element of the iteration for which `func` returned `true`
     */
    findLastIndex(func, options = {}) {
        var _a, e_8, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(func);
            let foundIndex = -1;
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_5 = __asyncValues(concIter), concIter_5_1; concIter_5_1 = yield concIter_5.next(), _a = concIter_5_1.done, !_a; _d = true) {
                    _c = concIter_5_1.value;
                    _d = false;
                    const elem = _c;
                    if (elem.mapped) {
                        foundIndex = elem.index;
                    }
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_5.return)) yield _b.call(concIter_5);
                }
                finally { if (e_8) throw e_8.error; }
            }
            return foundIndex;
        });
    }
    /**
     * Returns whether an element is present in this iteration.
     *
     * @remarks
     * If the element is found in the iteration, no more elements are iterated.
     *
     * @param obj - The element to search in the iteration
     * @returns A promise to whether `obj` is present in this iteration or not
     */
    includes(obj) {
        var _a, e_9, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                for (var _d = true, _e = __asyncValues(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                    _c = _f.value;
                    _d = false;
                    const elem = _c;
                    if (Object.is(obj, elem) || (obj === elem)) {
                        return true;
                    }
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_9) throw e_9.error; }
            }
            return false;
        });
    }
    /**
     * Returns `true` if calling `func(element)` returns `true` for at least one element, and `false` otherwise
     *
     * @remarks
     * If a call to `func(element)` returns `true`, no more elements are iterated.
     *
     * @param func - A function to be called on the elements of the iteration
     * @param options - Options for concurrency of this operation
     * @returns A promise to whether calling `func` returned `true` on at least one element.
     */
    some(func, options = {}) {
        var _a, e_10, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(func);
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_6 = __asyncValues(concIter), concIter_6_1; concIter_6_1 = yield concIter_6.next(), _a = concIter_6_1.done, !_a; _d = true) {
                    _c = concIter_6_1.value;
                    _d = false;
                    const item = _c;
                    if (item.mapped) {
                        return true;
                    }
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_6.return)) yield _b.call(concIter_6);
                }
                finally { if (e_10) throw e_10.error; }
            }
            return false;
        });
    }
    /**
     * Returns `true` if calling `func(element)` returns `true` for every element, and `false` otherwise
     *
     * @remarks
     * If a call to `func(element)` returns `false`, no more elements are iterated.
     *
     * @param func - A function to be called on the elements of the iteration
     * @param options - Options for concurrency of this operation
     * @returns A promise to whether calling `func` returned `true` for all elements.
     */
    every(func, options = {}) {
        var _a, e_11, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(func);
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_7 = __asyncValues(concIter), concIter_7_1; concIter_7_1 = yield concIter_7.next(), _a = concIter_7_1.done, !_a; _d = true) {
                    _c = concIter_7_1.value;
                    _d = false;
                    const item = _c;
                    if (!item.mapped) {
                        return false;
                    }
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_7.return)) yield _b.call(concIter_7);
                }
                finally { if (e_11) throw e_11.error; }
            }
            return true;
        });
    }
    reduce(reducer, init) {
        var _a, e_12, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(reducer);
            let accumulated = init;
            let isFirst = (accumulated === undefined);
            let idx = 0;
            try {
                for (var _d = true, _e = __asyncValues(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                    _c = _f.value;
                    _d = false;
                    const elem = _c;
                    accumulated = isFirst ? elem : yield reducer(accumulated, elem, idx);
                    isFirst = false;
                    idx++;
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_12) throw e_12.error; }
            }
            if (isFirst) {
                throw new TypeError('Reduce of empty iteration with no initial value');
            }
            return accumulated;
        });
    }
    /**
     * Return the number of elements on this iteration.
     *
     * @returns A promise to the number of elements in this iteration
     */
    count() {
        var _a, e_13, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            let count = 0;
            try {
                for (var _d = true, _e = __asyncValues(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f")), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                    _c = _f.value;
                    _d = false;
                    const _ = _c;
                    count++;
                }
            }
            catch (e_13_1) { e_13 = { error: e_13_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_13) throw e_13.error; }
            }
            return count;
        });
    }
    /**
     * Call a function for each element of `this` iteration.
     *
     * @param func - A function to be called for every element of the iteration
     * @param options - Options for concurrency of this operation
     * @returns A promise that will resolve when all calls have resolved
     */
    forEach(func, options = {}) {
        var _a, e_14, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            utils_js_1.asserts.isFunction(func);
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), func, options);
            try {
                for (var _d = true, concIter_8 = __asyncValues(concIter), concIter_8_1; concIter_8_1 = yield concIter_8.next(), _a = concIter_8_1.done, !_a; _d = true) {
                    _c = concIter_8_1.value;
                    _d = false;
                    const _elem = _c;
                }
            }
            catch (e_14_1) { e_14 = { error: e_14_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_8.return)) yield _b.call(concIter_8);
                }
                finally { if (e_14) throw e_14.error; }
            }
        });
    }
    /**
     * Return the result of joining the elements of `this` with the given `glue`, or `','` if no glue is given.
     *
     * @remarks
     * `null` or `undefined` elements are treated as empty strings.
     *
     * @param glue - The string to use for joining the elements
     * @param options - Options for concurrency of this operation
     * @returns A promise to a string concatenating all elements of `this` using the given `glue`
     */
    join(glue = ',', options = {}) {
        var _a, e_15, _b, _c;
        var _d;
        return __awaiter(this, void 0, void 0, function* () {
            let str = '';
            let first = true;
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), NOOP, options);
            try {
                for (var _e = true, concIter_9 = __asyncValues(concIter), concIter_9_1; concIter_9_1 = yield concIter_9.next(), _a = concIter_9_1.done, !_a; _e = true) {
                    _c = concIter_9_1.value;
                    _e = false;
                    const elem = _c;
                    str += (first ? '' : glue) + ((_d = elem.mapped) !== null && _d !== void 0 ? _d : '');
                    first = false;
                }
            }
            catch (e_15_1) { e_15 = { error: e_15_1 }; }
            finally {
                try {
                    if (!_e && !_a && (_b = concIter_9.return)) yield _b.call(concIter_9);
                }
                finally { if (e_15) throw e_15.error; }
            }
            return str;
        });
    }
    /**
     * Perform this iteration doing nothing.
     *
     * @param options - Options for concurrency of this operation
     * @returns a promise that will resolve when the iteration is done
     */
    complete(options = {}) {
        var _a, e_16, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            /* eslint-disable-next-line no-unused-vars */
            const concIter = new concurrency_js_1.ConcurrentMapper(__classPrivateFieldGet(this, _PolyAsyncIterable_iterable, "f"), NOOP, options);
            try {
                for (var _d = true, concIter_10 = __asyncValues(concIter), concIter_10_1; concIter_10_1 = yield concIter_10.next(), _a = concIter_10_1.done, !_a; _d = true) {
                    _c = concIter_10_1.value;
                    _d = false;
                    const _elem = _c;
                }
            }
            catch (e_16_1) { e_16 = { error: e_16_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = concIter_10.return)) yield _b.call(concIter_10);
                }
                finally { if (e_16) throw e_16.error; }
            }
        });
    }
    /**
     * Returns a tuple containing `num` iterables that will yield independent
     * copies of the elements yielded by `this`.
     *
     * @remarks
     * Note that, as with every other method of this class, this instance is unusable after calling this method.
     *
     * In order to provide a truly independent iteration for all returned iterables, a buffer is kept, which can grow as
     * big as the whole iteration in certain circumstances.  The buffer is filled as fast as the fastest iterable requests
     * new items, and emptied as fast as the slowest iterable consumes those items.
     *
     * @param num - the number of copies to be returned
     * @returns An array of `num` elements containing independent copies of this iterable
     */
    duplicate(num) {
        utils_js_1.asserts.isNonNegativeInteger(num);
        const it = this[Symbol.asyncIterator]();
        let offsIndex = 0; // index offset for when the buffer is shrunk
        const buffer = [];
        function generator() {
            return __asyncGenerator(this, arguments, function* generator_1() {
                let currIndex = 0;
                while (true) {
                    const index = currIndex - offsIndex;
                    if (buffer[index] == null) {
                        const item = yield __await(it.next());
                        buffer[index] = { item, pending: num };
                    }
                    if (buffer[index].item.done) {
                        return yield __await(void 0);
                    }
                    currIndex += 1;
                    buffer[index].pending -= 1;
                    yield yield __await(buffer[index].item.value);
                    while (buffer.length > 0 && buffer[0].pending <= 0 && !buffer[0].item.done) {
                        buffer.shift();
                        offsIndex += 1;
                    }
                }
            });
        }
        return Array(num).fill(null).map(() => new PolyAsyncIterable(generator()));
    }
}
exports.default = PolyAsyncIterable;
//# sourceMappingURL=poly-iterable.js.map