"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncIterableBuilder = exports.PolyAsyncIterable = exports.PolySyncIterable = exports.Poly = void 0;
/**
 * A library for working with iterables and async iterables in a functional style, by transforming the iterations on
 * the fly and getting results from them.
 *
 * @remarks
 * The entry point for this library is the {@link Poly} namespace, and the main iterable classes are
 * {@link PolySyncIterable} and {@link PolyAsyncIterable}.
 *
 * @packageDocumentation
 */
const poly_js_1 = require("./poly.js");
Object.defineProperty(exports, "Poly", { enumerable: true, get: function () { return poly_js_1.Poly; } });
const builder_js_1 = __importDefault(require("./builder.js"));
exports.AsyncIterableBuilder = builder_js_1.default;
const main_js_1 = require("./sync/main.js");
Object.defineProperty(exports, "PolySyncIterable", { enumerable: true, get: function () { return main_js_1.PolySyncIterable; } });
const poly_iterable_js_1 = __importDefault(require("./async/poly-iterable.js"));
exports.PolyAsyncIterable = poly_iterable_js_1.default;
exports.default = poly_js_1.Poly;
//# sourceMappingURL=main.js.map