"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.asserts = exports.isAsyncIterable = exports.isSyncIterable = exports.isNotNullish = exports.comparator = exports.asyncIdentity = exports.identity = void 0;
function identity(x) {
    return x;
}
exports.identity = identity;
function asyncIdentity(x) {
    return __awaiter(this, void 0, void 0, function* () {
        return x;
    });
}
exports.asyncIdentity = asyncIdentity;
function comparator(a, b) {
    return (a < b) ? -1 : (a > b) ? +1 : 0;
}
exports.comparator = comparator;
function isNotNullish(obj) {
    return obj != null;
}
exports.isNotNullish = isNotNullish;
function isSyncIterable(obj) {
    return typeof obj == 'object' && obj != null && Symbol.iterator in obj;
}
exports.isSyncIterable = isSyncIterable;
function isAsyncIterable(obj) {
    return typeof obj == 'object' && obj != null && Symbol.asyncIterator in obj;
}
exports.isAsyncIterable = isAsyncIterable;
exports.asserts = {
    isFunction(arg, name = 'argument') {
        if (typeof arg !== 'function') {
            throw new Error(`${name} should be a function`);
        }
        return true;
    },
    isInteger(arg, name = 'argument') {
        if (!Number.isInteger(arg)) {
            throw new Error(`${name} should be an integer`);
        }
        return true;
    },
    isPositiveInteger(arg, name = 'argument') {
        if (!Number.isInteger(arg) || arg <= 0) {
            throw new Error(`${name} should be a positive integer`);
        }
        return true;
    },
    isNonNegativeInteger(arg, name = 'argument') {
        if (!Number.isInteger(arg) || arg < 0) {
            throw new Error(`${name} should be a non-negative integer`);
        }
        return true;
    },
    isSyncIterable(arg, name = 'argument') {
        const iteratorMethod = arg[Symbol.iterator];
        if (typeof iteratorMethod !== 'function') {
            throw new Error(`${name} should be sync iterable`);
        }
        return true;
    },
    isAsyncIterable(arg, name = 'argument') {
        const asyncIteratorMethod = arg[Symbol.asyncIterator];
        if (typeof asyncIteratorMethod !== 'function') {
            throw new Error(`${name} should be async iterable`);
        }
        return true;
    },
    isSyncOrAsyncIterable(arg, name = 'argument') {
        const iteratorMethod = arg[Symbol.iterator];
        const asyncIteratorMethod = arg[Symbol.asyncIterator];
        if (typeof iteratorMethod !== 'function' && typeof asyncIteratorMethod !== 'function') {
            throw new Error(`${name} should be sync or async iterable`);
        }
        return true;
    },
};
//# sourceMappingURL=utils.js.map