import { AsyncChunkingPredicate, AsyncIndexedMapping, AsyncIndexedPredicate, AsyncIndexedRunnable, Comparator, IndexedTypePredicate } from '../types.js';
import { ConcurrencyOptions } from './poly-iterable.js';
export declare function prefetchGen<T>(iterable: AsyncIterable<T>): AsyncIterable<T>;
export declare function appendGen<T, U>(iterA: Iterable<T> | AsyncIterable<T>, iterB: Iterable<U> | AsyncIterable<U>): AsyncIterable<T | U>;
export declare function prependGen<T, U>(iterA: Iterable<T> | AsyncIterable<T>, iterB: Iterable<U> | AsyncIterable<U>): AsyncIterable<T | U>;
export declare function dropGen<T>(iter: AsyncIterable<T>, num: number): AsyncIterable<T>;
export declare function takeGen<T>(iter: AsyncIterable<T>, num: number): AsyncIterable<T>;
export declare function dropLastGen<T>(iter: AsyncIterable<T>, num: number): AsyncIterable<T>;
export declare function takeLastGen<T>(iter: AsyncIterable<T>, num: number): AsyncIterable<T>;
export declare function dropWhileGen<T>(iter: AsyncIterable<T>, func: AsyncIndexedPredicate<T>): AsyncIterable<T>;
export declare function takeWhileGen<T>(iter: AsyncIterable<T>, func: AsyncIndexedPredicate<T>): AsyncIterable<T>;
export declare function sliceGen<T>(iter: AsyncIterable<T>, start: number, end?: number): AsyncIterable<T>;
export declare function filterGen<T, U extends T>(iter: AsyncIterable<T>, func: IndexedTypePredicate<T, U>, options: ConcurrencyOptions): AsyncIterable<U>;
export declare function filterGen<T>(iter: AsyncIterable<T>, func: AsyncIndexedPredicate<T>, options: ConcurrencyOptions): AsyncIterable<T>;
export declare function mapGen<T, U>(iter: AsyncIterable<T>, func: AsyncIndexedMapping<T, U>, options: ConcurrencyOptions): AsyncIterable<U>;
export declare function tapGen<T>(iter: AsyncIterable<T>, func: AsyncIndexedRunnable<T>, options: ConcurrencyOptions): AsyncIterable<T>;
export declare function flattenGen<T>(iter: AsyncIterable<Iterable<T> | AsyncIterable<T>>): AsyncIterable<T>;
export declare function chunkGen<T>(iter: AsyncIterable<T>, num: number): AsyncIterable<Array<T>>;
export declare function chunkWhileGen<T>(iter: AsyncIterable<T>, func: AsyncChunkingPredicate<T>): AsyncIterable<Array<T>>;
export declare function groupByGen<K, T>(iter: AsyncIterable<T>, func: AsyncIndexedMapping<T, K>, options: ConcurrencyOptions): AsyncIterable<[K, Array<T>]>;
export declare function uniqueGen<T>(iter: AsyncIterable<T>, func: AsyncIndexedMapping<T, unknown>, options: ConcurrencyOptions): AsyncIterable<T>;
export declare function reverseGen<T>(iter: AsyncIterable<T>): AsyncIterable<T>;
export declare function sortGen<T>(iter: AsyncIterable<T>, func: Comparator<T>): AsyncIterable<T>;
//# sourceMappingURL=generators.d.ts.map