import PolySyncIterable from './poly-sync-iterable.js';
class FilterSyncIterator {
    #predicate;
    #iterator;
    #index = 0;
    constructor(iterator, predicate) {
        this.#iterator = iterator;
        this.#predicate = predicate;
    }
    next() {
        let elem;
        do {
            elem = this.#iterator.next();
        } while (!elem.done && !this.#predicate(elem.value, this.#index++));
        return elem;
    }
}
export default class FilterSyncIterable extends PolySyncIterable {
    #iterable;
    #filter;
    constructor(iterable, filter) {
        super();
        this.#iterable = iterable;
        this.#filter = filter;
    }
    static create(iterable, filter) {
        return new FilterSyncIterable(iterable, filter);
    }
    [Symbol.iterator]() {
        return new FilterSyncIterator(this.#iterable[Symbol.iterator](), this.#filter);
    }
}
//# sourceMappingURL=filter-sync-iterable.js.map