import { ChunkingPredicate, Comparator, IndexedMapping, IndexedPredicate, IndexedRunnable, IndexedTypePredicate } from '../types.js';
export declare function appendGen<T, U>(iterA: Iterable<T>, iterB: Iterable<U>): Iterable<T | U>;
export declare function prependGen<T, U>(iterA: Iterable<T>, iterB: Iterable<U>): Iterable<T | U>;
export declare function dropGen<T>(iter: Iterable<T>, num: number): Iterable<T>;
export declare function takeGen<T>(iter: Iterable<T>, num: number): Iterable<T>;
export declare function dropLastGen<T>(iter: Iterable<T>, num: number): Iterable<T>;
export declare function takeLastGen<T>(iter: Iterable<T>, num: number): Iterable<T>;
export declare function sliceGen<T>(iter: Iterable<T>, start: number, end?: number): Iterable<T>;
export declare function dropWhileGen<T>(iter: Iterable<T>, func: IndexedPredicate<T>): Iterable<T>;
export declare function takeWhileGen<T>(iter: Iterable<T>, func: IndexedPredicate<T>): Iterable<T>;
export declare function filterGen<T, U extends T>(iter: Iterable<T>, func: IndexedTypePredicate<T, U>): Iterable<U>;
export declare function filterGen<T>(iter: Iterable<T>, func: IndexedPredicate<T>): Iterable<T>;
export declare function mapGen<T, U>(iter: Iterable<T>, func: IndexedMapping<T, U>): Iterable<U>;
export declare function tapGen<T>(iter: Iterable<T>, func: IndexedRunnable<T>): Iterable<T>;
export declare function flattenGen<T>(iter: Iterable<Iterable<T>>): Iterable<T>;
export declare function chunkGen<T>(iter: Iterable<T>, num: number): Iterable<Array<T>>;
export declare function chunkWhileGen<T>(iter: Iterable<T>, func: ChunkingPredicate<T>): Iterable<Array<T>>;
export declare function groupByGen<K, T>(iter: Iterable<T>, func: IndexedMapping<T, K>): Iterable<[K, Array<T>]>;
export declare function uniqueGen<T>(iter: Iterable<T>, func: IndexedMapping<T, unknown>): Iterable<T>;
export declare function reverseGen<T>(iter: Iterable<T>): Iterable<T>;
export declare function sortGen<T>(iter: Iterable<T>, func: Comparator<T>): Iterable<T>;
//# sourceMappingURL=generators.d.ts.map