export declare function identity<T>(x: T): T;
export declare function asyncIdentity<T>(x: T): Promise<T>;
export declare function comparator<T>(a: T, b: T): -1 | 0 | 1;
export declare function isNotNullish<T>(obj: T): obj is NonNullable<T>;
export declare function isSyncIterable<T>(obj: unknown): obj is Iterable<T>;
export declare function isAsyncIterable<T>(obj: unknown): obj is AsyncIterable<T>;
export declare const asserts: {
    isFunction(arg: any, name?: string): arg is Function;
    isInteger(arg: any, name?: string): arg is number;
    isPositiveInteger(arg: any, name?: string): arg is number;
    isNonNegativeInteger(arg: any, name?: string): arg is number;
    isSyncIterable(arg: any, name?: string): arg is Iterable<any>;
    isAsyncIterable(arg: any, name?: string): arg is AsyncIterable<any>;
    isSyncOrAsyncIterable(arg: any, name?: string): arg is Iterable<any> | AsyncIterable<any>;
};
//# sourceMappingURL=utils.d.ts.map